import org.svetovid.SvetovidFormatException;
import org.svetovid.io.SvetovidReader;
import org.svetovid.io.SvetovidWriter;

/**
 * Format:
 *
 * id vrednost
 * levi
 * desni
 */
public class StabloIOIndent implements StabloIO {

    protected String nullSymbol;
    protected String indent;

    public StabloIOIndent() {
        this("-", "    ");
    }

    public StabloIOIndent(String nullSymbol, String indent) {
        this.nullSymbol = nullSymbol;
        this.indent = indent;
    }

    public String getNullSymbol() {
        return nullSymbol;
    }

    public void setNullSymbol(String nullSymbol) {
        this.nullSymbol = nullSymbol;
    }

    public String getIndent() {
        return indent;
    }

    public void setIndent(String indent) {
        this.indent = indent;
    }

    @Override
    public Stablo readStablo(SvetovidReader in) {
        try {
            int id = in.readInt();
            String vrednost = in.readLine();
            Stablo levi = readStablo(in);
            Stablo desni = readStablo(in);
            Stablo stablo = new Stablo(id, vrednost, levi, desni);
            return stablo;
        } catch (SvetovidFormatException e) {
            return null;
        }
    }

    @Override
    public void printStablo(SvetovidWriter out, Stablo stablo) {
        write(out, stablo, nullSymbol, indent, "");
    }

    protected void write(SvetovidWriter out, Stablo stablo, String nullSymbol, String indent, String prefix) {
        if (stablo == null) {
            out.println(prefix + nullSymbol);
            return;
        }
        int id = stablo.id;
        String vrednost = stablo.vrednost;
        out.print(prefix);
        out.println(id, vrednost);
        write(out, stablo.levi, nullSymbol, indent, prefix + indent);
        write(out, stablo.desni, nullSymbol, indent, prefix + indent);
    }
}
