import java.util.Arrays;
import java.util.Comparator;

/*
 * Sortiranje
 * Domaci zadatak za mozganje #1
 *
 * a) Zasto ovaj program ne sortira niz datuma kako se ocekuje?
 * b) Kako popraviti program?
 */

// Tip podataka
class Datum {

    public final Integer dan;
    public final Integer mesec;
    public final Integer godina;

    public Datum(String datum) {

        // Razdvojimo string oko tacaka
        String[] komponente = datum.split("\\.");

        // Konvertujemo stringove u brojeve
        dan = Integer.valueOf(komponente[0]);
        mesec = Integer.valueOf(komponente[1]);
        godina = Integer.valueOf(komponente[2]);

    }

    @Override
    public String toString() {
        return dan + "." + mesec + "." + godina + ".";
    }
}

public class DomaciZadatakZaMozganje1 {

    public static void main(String[] args) {

        // Kreiramo niz datuma
        Datum[] datumi = new Datum[] {
                new Datum("11.4.2015."),
                new Datum("12.5.2013."),
                new Datum("21.5.2015."),
                new Datum("11.4.2014."),
                new Datum("14.4.2015."),
                new Datum("14.4.2014."),
                new Datum("21.4.2015."),
                new Datum("12.5.2014."),
                new Datum("11.4.2013."),
                new Datum("12.5.2015."),
                new Datum("14.4.2013."),
                new Datum("16.5.2015.")
        };

        // Odstampamo niz
        Svetovid.out.println("Originalni niz:");
        for (Datum datum : datumi) {
            Svetovid.out.println(datum);
        }

        // Sortiramo niz
        Arrays.sort(datumi, new KomparatorDatuma());

        // Ponovo odstampamo niz
        Svetovid.out.println("Sortirani niz:");
        for (Datum datum : datumi) {
            Svetovid.out.println(datum);
        }

    }
}

class KomparatorDatuma implements Comparator<Datum> {

    private Comparator<Integer> komparator = new ObrnutiKomparatorBrojeva();

    @Override
    public int compare(Datum datum1, Datum datum2) {

        // Prvo poredimo godine
        int rezultat = komparator.compare(datum1.godina, datum2.godina);

        // Ako su godine jednake, poredimo mesece
        if (rezultat == 0) {
            rezultat = komparator.compare(datum1.mesec, datum2.mesec);
        }

        // Ako su i meseci jednaki poredimo dane
        if (rezultat == 0) {
            rezultat = komparator.compare(datum1.dan, datum2.dan);
        }

        // Vratimo rezultat poredjenja
        return rezultat;

    }
}

class ObrnutiKomparatorBrojeva implements Comparator<Integer> {

    @Override
    public int compare(Integer int1, Integer int2) {
        if (int1 == int2) {
            return 0;
        } else if (int1 < int2) {
            return 1;
        } else {
            return -1;
        }
    }
}
